package cn.estsh.i3plus.pojo.ptl.bean;


import cn.estsh.i3plus.pojo.base.annotation.DynamicField;
import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import cn.estsh.i3plus.pojo.base.enumutil.WmsEnumUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @author Wynne.Lu
 * @date 2020/2/12 17:41
 * @desc
 */

@Data
@Entity
@DynamicInsert
@DynamicUpdate
@Table(name = "PTL_AREA_ACTOR_ACTION")
@EqualsAndHashCode(callSuper = true)
@Api("PTL_区域观察者事件配置")
public class PtlAreaActorAction extends BaseBean implements Serializable {
    private static final long serialVersionUID = -1596837642283797995L;

    @Column(name = "AREA_NO")
    @ApiParam("区域代码")
    @DynamicField(webFieldType = WmsEnumUtil.FIELD_TYPE.TEXT)
    private String areaNo;

    @Column(name = "ACTOR_CODE")
    @DynamicField(webFieldType = WmsEnumUtil.FIELD_TYPE.TEXT)
    @ApiParam("观察者编码")
    private String actorCode;

    @Column(name = "MT_CODE")
    @DynamicField(webFieldType = WmsEnumUtil.FIELD_TYPE.TEXT)
    @ApiParam("消息类型代码")
    private String mtCode;

    @Column(name = "OTHER_WHERE")
    @DynamicField(webFieldType = WmsEnumUtil.FIELD_TYPE.TEXT)
    @ApiParam("特定条件")
    private String otherWhere;

    @Column(name = "AMG_ID")
    @DynamicField(webFieldType = WmsEnumUtil.FIELD_TYPE.TEXT)
    @ApiParam("组件集编号")
    private Long amgId;
}
