package cn.estsh.i3plus.pojo.ptl.bean;


import cn.estsh.i3plus.pojo.base.annotation.DynamicField;
import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import cn.estsh.i3plus.pojo.base.enumutil.WmsEnumUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @author Wynne.Lu
 * @date 2020/2/12 17:41
 * @desc
 */

@Data
@Entity
@DynamicInsert
@DynamicUpdate
@Table(name = "PTL_AREA_ROUTE_MODULE_PARAM")
@EqualsAndHashCode(callSuper = true)
@Api("PTL_区域流程组件调用参数")
public class PtlAreaRouteModuleParam extends BaseBean implements Serializable {
    private static final long serialVersionUID = -1596829442283797995L;

    @Column(name = "AREA_NO")
    @ApiParam("区域代码")
    @DynamicField(webFieldType = WmsEnumUtil.FIELD_TYPE.TEXT)
    private String areaNo;

    @Column(name = "ROUTE_CODE")
    @DynamicField(webFieldType = WmsEnumUtil.FIELD_TYPE.TEXT)
    @ApiParam("流程代码")
    private String routeCode;

    @Column(name = "AMG_ID")
    @DynamicField(webFieldType = WmsEnumUtil.FIELD_TYPE.TEXT)
    @ApiParam("组件集编号")
    private Long amgId;

    @Column(name = "AM_CODE")
    @DynamicField(webFieldType = WmsEnumUtil.FIELD_TYPE.TEXT)
    @ApiParam("组件代码")
    private String amCode;

    @Column(name = "PARAM_CODE")
    @DynamicField(webFieldType = WmsEnumUtil.FIELD_TYPE.TEXT)
    @ApiParam("参数代码")
    private String paramCode;

    @Column(name = "PARAM_VALUE")
    @DynamicField(webFieldType = WmsEnumUtil.FIELD_TYPE.TEXT)
    @ApiParam("参数值")
    private String paramValue;

    @Column(name = "STATUS_CODE")
    @ApiParam("状态代码")
    private String statusCode;
}
