package cn.estsh.i3plus.pojo.ptl.bean;


import cn.estsh.i3plus.pojo.base.annotation.DynamicField;
import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import cn.estsh.i3plus.pojo.base.enumutil.WmsEnumUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @author Wynne.Lu
 * @date 2020/2/12 17:41
 * @desc
 */

@Data
@Entity
@DynamicInsert
@DynamicUpdate
@Table(name = "PTL_IF")
@EqualsAndHashCode(callSuper = true)
@Api("PTL_接口清单")
public class PtlIf extends BaseBean implements Serializable {
    private static final long serialVersionUID = -1596882732758197995L;

    @Column(name = "IF_CODE")
    @ApiParam("接口代码")
    @DynamicField(webFieldType = WmsEnumUtil.FIELD_TYPE.TEXT)
    private String ifCode;

    @Column(name = "IF_NAME")
    @DynamicField(webFieldType = WmsEnumUtil.FIELD_TYPE.TEXT)
    @ApiParam("接口名称")
    private String ifName;

    @Column(name = "IF_CONNECT_TYPE")
    @DynamicField(webFieldType = WmsEnumUtil.FIELD_TYPE.SELECT)
    @ApiParam("交互方式")
    private String ifConnectType;

    @Column(name = "IF_CLASS")
    @DynamicField(webFieldType = WmsEnumUtil.FIELD_TYPE.SELECT)
    @ApiParam("接口实现类")
    private String ifClass;

    @Column(name = "IF_CALL_TYPE")
    @DynamicField(webFieldType = WmsEnumUtil.FIELD_TYPE.SELECT)
    @ApiParam("接口调用方向")
    private String ifCallType;
}
