package cn.estsh.i3plus.pojo.ptl.bean;


import cn.estsh.i3plus.pojo.base.annotation.DynamicField;
import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import cn.estsh.i3plus.pojo.base.enumutil.WmsEnumUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @author Wynne.Lu
 * @date 2020/2/12 17:41
 * @desc
 */

@Data
@Entity
@DynamicInsert
@DynamicUpdate
@Table(name = "PTL_RFID")
@EqualsAndHashCode(callSuper = true)
@Api("PTL_RFID")
public class PtlRfid extends BaseBean implements Serializable {
    private static final long serialVersionUID = -1596837642758197995L;

    @Column(name = "RFID_CONTROL_NO")
    @ApiParam("RFID读写器代码")
    @DynamicField(webFieldType = WmsEnumUtil.FIELD_TYPE.TEXT)
    private String rfidControlNo;

    @Column(name = "IP")
    @DynamicField(webFieldType = WmsEnumUtil.FIELD_TYPE.TEXT)
    @ApiParam("IP")
    private String ip;

    @Column(name = "PORT")
    @DynamicField(webFieldType = WmsEnumUtil.FIELD_TYPE.TEXT)
    @ApiParam("端口号")
    private String port;

    @Column(name = "AREA_NO")
    @DynamicField(webFieldType = WmsEnumUtil.FIELD_TYPE.SELECT)
    @ApiParam("区域代码")
    private String areaNo;

    @Column(name = "RFID_VALUE")
    @DynamicField(webFieldType = WmsEnumUtil.FIELD_TYPE.TEXT)
    @ApiParam("rfid内容")
    private String rfidValue;
}
