package cn.estsh.i3plus.pojo.ptl.bean;


import cn.estsh.i3plus.pojo.base.annotation.DynamicField;
import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import cn.estsh.i3plus.pojo.base.enumutil.WmsEnumUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * @author Wynne.Lu
 * @date 2020/2/12 17:41
 * @desc
 */

@Data
@Entity
@DynamicInsert
@DynamicUpdate
@Table(name = "PTL_WINDOW")
@EqualsAndHashCode(callSuper = true)
@Api("PTL_界面")
public class PtlWindow extends BaseBean implements Serializable {
    private static final long serialVersionUID = -1596443842758197995L;

    @Column(name = "WINDOW_NO")
    @ApiParam("界面代码")
    @DynamicField(webFieldType = WmsEnumUtil.FIELD_TYPE.TEXT)
    private String windowNo;

    @Column(name = "WINDOW_NAME")
    @DynamicField(webFieldType = WmsEnumUtil.FIELD_TYPE.TEXT)
    @ApiParam("界面名称")
    private String windowName;
}
