package cn.estsh.i3plus.pojo.wms.modelbean;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import lombok.Data;
import org.hibernate.annotations.ColumnDefault;

/**
 * @Description : 移库单数据模型Model
 * @Reference :
 * @Author : siliter.yuan
 * @CreateDate : 2020-03-26 11:18
 * @Modify:
 **/
@Data
@AllArgsConstructor
@Api("移库单数据模型")
public class WmsDocMovementModel {

    @ApiParam("订单号")
    private String orderNo;

    @ApiParam(value = "业务类型", example = "1")
    private Integer busiType;

    @ApiParam("客户代码")
    private String custNo;

    @ApiParam("来源仓库代码")
    private String srcWhNo;

    @ApiParam("来源存储区代码")
    private String srcZoneNo;

    @ApiParam("目标仓库代码")
    private String destWhNo;

    @ApiParam("目标存储区代码")
    private String destZoneNo;

    @ApiParam("物料组代码")
    private String partGroupNo;

    @ApiParam("订单状态")
    private String orderStatus;

    @ApiParam(value = "优先级", example = "1")
    public Integer priority;

    @ApiParam("物料号")
    private String partNo;

    @ColumnDefault("0")
    @ApiParam(value = "已拣货数量", example = "1")
    private Double pickQty;

    @ColumnDefault("0")
    @ApiParam(value = "已出库数量", example = "1")
    private Double outQty;

    @ColumnDefault("0")
    @ApiParam(value = "已移库数量", example = "1")
    private Double moveQty;

    @ColumnDefault("0")
    @ApiParam(value = "需求数量", example = "0")
    public Double qty;

    @ApiParam("源单行号")
    public String srcItem;

    @ApiParam(value = "源单号")
    private String srcNo;

    @ApiParam("物料号")
    private String partNameRdd;

    @ApiParam("单位")
    private String unit;

    @ApiParam(value = "标准包装", example = "1")
    private Double snp;

    @ApiParam(value = "一步法/两步法")
    private Integer isSingleStep;

    @ApiParam(value = "创建时间")
    private String createDateTime;
}
